#ifndef sPacket_h
#define sPacket_h
#include "misc.h"

/*
typedef struct {
	uint8_t   proto;
	uint32_t  pay_len;
	uint8_t	  opcode;
	uint8_t	  data[1];
	} __attribute__ ((packed)) cPacket;
*/

class sPacket {
	private:
	uint8_t		 proto;
	uint32_t	 pay_len;
	uint8_t		 opcode;
	char		*data;

static  int		 count;
	size_t		 size;
	size_t		 pos;
	/* next sPacket waiting to be send (only SEND) */
//	sPacket		*next;
	public:
 	int		 status;
	void		 Work 		(void) { };
static  int 		 Count 		( ) { return count; }	
			 sPacket 	(void);
			 sPacket 	(uint8_t cmd, size_t Size);
			~sPacket	(void);
	bool		 readReset	(void);
	int 		 Read 		(class cSocket *Socket);	
	int 		 Send		(class cSocket *Socket);
	bool		 Full		(void) const { return status == 101; }
	uint32_t	 Unused		(void) const { return pay_len - pos - 1; }
	uint32_t	 Length		(void) const { return pay_len;    }
	uint8_t		 Command	(void) const { return opcode; }
	uint8_t		 Proto		(void) const { return proto; }
//	sPacket		*Next		(void      ) { return next; }
	void		 Proto		(uint8_t p);
	void		 Paylen		(size_t  p);
	void		 Opcode		(uint8_t p);

	bool		 ADD_HASH	(const uint8_t *hash);
	bool		 ADD_F4  	(float	     val);
	bool		 ADD_U4  	(uint32_t    val);
	bool		 ADD_U2  	(uint16_t    val);
	bool		 ADD_U1  	(uint8_t     val);
	bool		 ADD_S2  	(const char *val);
	bool		 ADD_BLIND	(uint32_t len);
	bool		 ADD_DATA	(const char *dat,size_t len);

	bool 		 GET_HASH	(tHash &hash);
	float     	 GET_F4 	(void);
	uint32_t  	 GET_U4 	(void);
	uint16_t	 GET_U2 	(void);
	uint8_t 	 GET_U1 	(void);
	char		*GET_S2 	(void);
	void		 GET_BLIND	(unsigned);
	void*		 DATA		(void);
	void		 Dump		(void) const;
//	void		SetNext		(sPacket *addnext) { next = addnext; }
	};
#endif
